import { Semaphore } from "../semaphore";
var Mutex = (function () {
    function Mutex() {
        this.semaphore = new Semaphore(1);
    }
    Object.defineProperty(Mutex.prototype, "isLocked", {
        get: function () {
            return this.queueLength !== 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Mutex.prototype, "queueLength", {
        get: function () {
            return this.semaphore.queueLength;
        },
        enumerable: false,
        configurable: true
    });
    Mutex.prototype.lock = function () {
        return this.semaphore.acquire(1);
    };
    Mutex.prototype.tryLock = function (timeout) {
        return this.semaphore.tryAcquire(timeout, 1);
    };
    Mutex.prototype.unlock = function () {
        this.semaphore.release();
    };
    Mutex.prototype.interrupt = function (reason) {
        this.semaphore.interrupt(reason, 1);
    };
    return Mutex;
}());
export { Mutex };
//# sourceMappingURL=mutex.js.map